//: C02:MemCheck.cpp {O}
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cstddef>
using namespace std;
#undef new

// Globální příznaky nastavované makry ze souboru MemCheck.h

bool traceFlag = true;
bool activeFlag = false;

namespace {

// Typ představující položku mapy paměti
struct Info {
  void* ptr;
  const char* file;
  long line;
};

// data mapy paměti
const size_t MAXPTRS = 10000u;
Info memMap[MAXPTRS];
size_t nptrs = 0;

// hledá adresu v mapě
int findPtr(void* p) {
  for(size_t i = 0; i < nptrs; ++i)
    if(memMap[i].ptr == p)
      return i;
  return -1;
}

void delPtr(void* p) {
  int pos = findPtr(p);
  assert(pos >= 0);
  // odstranit ukazatel z mapy
  for(size_t i = pos; i < nptrs-1; ++i)
    memMap[i] = memMap[i+1];
  --nptrs;
}

// náhražkový typ pro statický destruktor
struct Sentinel {
  ~Sentinel() {
    if(nptrs > 0) {
      printf("Uniklá paměť na:\n");
      for(size_t i = 0; i < nptrs; ++i)
        printf("\t%p (Soubor: %s, řádek %ld)\n",
          memMap[i].ptr, memMap[i].file, memMap[i].line);
    }
    else
      printf("Žádná uživatelská paměť neuniká!\n");
  }
};

// statický náhražkový objekt
Sentinel s;

} // konec anonymního prostoru jmen

// přetížit skalární operátor new
void*
operator new(size_t siz, const char* file, long line) {
  void* p = malloc(siz);
  if(activeFlag) {
    if(nptrs == MAXPTRS) {
      printf("Příliš malá mapa paměti (zvětšte MAXPTRS)\n");
      exit(1);
    }
    memMap[nptrs].ptr = p;
    memMap[nptrs].file = file;
    memMap[nptrs].line = line;
    ++nptrs;
  }
  if(traceFlag) {
    printf("Alokováno %u bytů na adrese %p ", siz, p);
    printf("(soubor: %s, řádek: %ld)\n", file, line);
  }
  return p;
}

// přetížit operátor new pro pole
void*
operator new[](size_t siz, const char* file, long line) {
  return operator new(siz, file, line);
}

// Přetížit skalární operátor delete
void operator delete(void* p) {
  if(findPtr(p) >= 0) {
    free(p);
    assert(nptrs > 0);
    delPtr(p);
    if(traceFlag)
      printf("Uvolněna paměť na adrese %p\n", p);
  }
  else if(p && activeFlag)
    printf("Pokus o smazání neznámého ukazatele: %p\n", p);
}

// Přetížit operátor delete pro pole
void operator delete[](void* p) {
  operator delete(p);
} ///:~
